<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionPerfil }}</strong>
    </div>
    <!--Contenido-->
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">
        {{ textoGestionPerfil }}
      </div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            Descripción
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              v-model.trim="perfil.descripcion"
              outlined
              solo
              maxlength="50"
              flat
              dense
              :error="$v.perfil.descripcion.error"
              hint-align="right"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(perfil.descripcion, 50)
              "
              background-color="white"
            >
              <template v-if="$v.perfil.descripcion.$error" v-slot:append>
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div @click="$v.perfil.descripcion.$reset" v-close-popover>
                      <div v-if="!$v.perfil.descripcion.required">
                        ¡No te olvides de éste campo!
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
        </v-row>
      </div>
      <div class="btnCenter">
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingPerfil },
            { 'error-validation-btn': $v.$invalid },
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </div>
    <!-- Dialogs-->
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡Se agrego un nuevo perfil
              <strong>de manera exitosa!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                :to="toEditPerfil()"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Entiendo</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.categorias {
  height: 48px;
}
.rowInactive .tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}
.ponderacion .fixed.tooltiptext3 .fixed.tooltiptext4 {
  bottom: -15px;
  left: -40px;
}
.ponderacion .tooltiptext3 .tooltiptext4 {
  bottom: -40px;
  left: -60px;
}
.titSec .tooltiptext3 .tooltiptext4 {
  bottom: -30px;
  left: -40px;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import store from "@/store";
import { required } from "vuelidate/lib/validators";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-NuevoPerfil",
  components: {
    LeavePage,
  },
  data() {
    return {
      savingPerfil: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidation: false,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Accesos",
          disabled: false,
          exact: true,
          to: {
            name: "accesos",
          },
        },
        {
          text: "Perfiles",
          disabled: false,
          exact: true,
          to: {
            name: "accesos_perfiles",
          },
        },
        {
          text: "Nuevo",
          disabled: true,
        },
      ],
      perfilBackup: {
        idPerfil: null,
        descripcion: "",
      },
      perfil: {
        idPerfil: null,
        descripcion: "",
      },
      textoGestionPerfil: null,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.perfilBackup) {
        const originalValue = JSON.stringify(this.perfilBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.perfil).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.perfil.idPerfil === undefined;
      }
    },
  },
  validations: {
    perfil: {
      descripcion: {
        required,
      },
    },
  },
  methods: {
    guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        this.savingPerfil = true;
        let body = {
          descripcion: this.perfil.descripcion,
        };
        axios
          .post("/accesos/sistema/perfiles/v1/", body)
          .then((response) => {
            let data = response.data;
            if (data) {
              this.perfil.idPerfil = data.resultado.id;
            }
            this.perfilBackup = JSON.parse(JSON.stringify(this.perfil));
            this.dialogSave = true;
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          })
          .finally(() => {
            this.savingPerfil = false;
          });
      } else {
        this.dialogErrorValidation = true;
      }
    },
    toEditPerfil() {
      return {
        name: "accesos_perfiles_edicion",
        params: {
          perfil: this.serviceCommons.objectToBase64(this.perfil),
        },
      };
    },
    cancelGlobalChanges() {
      this.perfil = JSON.parse(JSON.stringify(this.perfilBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    initValues() {
      this.textoGestionPerfil = "Crear Perfil";
    },
  },
  created() {
    this.perfilBackup = JSON.parse(JSON.stringify(this.perfil));
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  },
};
</script>
